#include <def21065l.h>           		

#define FRAMED_MODE
//#define UNFRAMED_MODE

.section/dm seg_dmda;
	.var dest;
	.var counter = 0;

.section/pm seg_rth;
	nop;nop;nop;nop;
	nop;jump start;
	
.section/pm seg_sp;
	nop;jump isr; rti;rti;

.section/pm seg_pmco;
isr:
	r3 = dm(RX0_A);
	dm(dest) = r3;
	
	r0 = dm(counter);
	comp(r0,r1);
	if eq jump reconfigure;
	
	r6 = dm(counter);
	r6 = r6 + 1;
	dm(counter) = r6;
	
	comp(r6,r7);
	if eq rti;
	
	comp(r3,r5);
	if ne jump error;
	
	rti;

.section/pm seg_pmco;
reconfigure:
#ifdef UNFRAMED_MODE
	r0 = SPEN_A|SLEN16|LRFS|LAFS |CKRE;
#endif
	
#ifdef FRAMED_MODE
	r0 = SPEN_A|SLEN16|LRFS|LAFS|RFSR|CKRE;
#endif
	dm(SRCTL0) = r0;
	
	r2 = 1;
	dm(counter) = r2;
	
	rti;

.section/pm seg_pmco;
start:
	bit set mode1 IRPTEN;
	bit set imask SPR0I;
	 
	r0 = 0x0;
	dm(SRCTL0) = r0;
	
	r1 = 0x0;
	r7 = 0x2;
	
	r5 = 0x4693;
	
#ifdef UNFRAMED_MODE	
	r0 = SPEN_A|SLEN15|LRFS|LAFS|CKRE;
#endif
#ifdef FRAMED_MODE
	r0 = SPEN_A|SLEN15|LRFS|LAFS|RFSR|CKRE;
#endif
	dm(SRCTL0) = r0;
	
	nop;
	nop;
	jump(pc,0);
	
error:
	r0 = 0x0;
	dm(SRCTL0) = r0;
	
	nop;
	nop;
	jump(pc,0);
