#include <def21161.h>

#define FRAMED_MODE
//#define UNFRAMED_MODE

#define SPICTL_FRAME SPIEN|SPTINT|SPRINT|MS|PSSE|BAUDR3|FLS1|WL16|DCPH0|NSMLS|CP|CPHASE|DF
#define SPICTL_UNFRAME  SPIEN|SPTINT|SPRINT|MS|PSSE|BAUDR3|FLS1|WL16|CP|CPHASE|DF

.segment /dm seg_dmda;
.var SPI_RX_dummy;

.endseg;

// PM interrupt vector code 
.section /pm   seg_rth;
Reserved_1:     rti; 
                nop; 
                nop; 
                nop;
Chip_Reset:     nop; 
                jump start; 
                nop; 
                nop;


.section/pm seg_pmco;
start:

  bit set mode2 FLG1O;   

  // Setup SPI DMA increments

  r0 = 0x0; dm(SPICTL) = r0; // Reset SPI interface   
  
  r0 = 0;
  dm(LCTL) = r0;

  R4 = 0x4693;		

	// Setup SPI interface for TX
#ifdef FRAMED_MODE
  r0 = SPICTL_FRAME;
#endif
#ifdef UNFRAMED_MODE
  r0 = SPICTL_UNFRAME;
#endif

  dm(SPICTL) = r0;  


  dm(SPITX) = r4;   
  	
loop_forever:  lcntr = 1000, do (PC,1) until lce;
  	nop;
  	
  r8 = dm(SPIRX) ;	
  dm(SPITX) = r4; 
  
  jump loop_forever;  	

.endseg;

